const https = require("https");
const url =
    "http://169.254.169.254/latest/meta-data/";
const axios = require('axios');

function InstanceManager(params) {
    this.params = [];
    if (params) this.tablename = params.tablename;
    this.metas = (!params)?[
        'ami-id',
        'instance-id',
        'local-hostname',
        'local-ipv4',
        'public-hostname',
        'public-ipv4',
        'security-groups',
        'placement/availability-zone'
    ]:((!params.metas) ? [
        'ami-id',
        'instance-id',
        'local-hostname',
        'local-ipv4',
        'public-hostname',
        'public-ipv4',
        'security-groups',
        'placement/availability-zone'
    ] : params.metas);
    this.parse = function (params) {
        let it = this;
        if (params && params.tablename) this.tablename = params.tablename;
        return new Promise(function (result) {
            for (let i = 0;i < it.metas.length; i++) {
                let tag = it.metas[i];
                axios
                    .get(url+tag)
                    .then(response => {
                        let data = response.data;
                        if (data){
                            if (tag === 'placement/availability-zone') tag = 'region';
                            if (tag === 'region') {
                                let t = tag.replace('-', '_');
                                it.params.push(t);
                                let field = data.split("-");
                                let proper = field[0]+"-"+field[1]+"-1"
                                it[tag] = proper;
                                process.env[tag] = proper;
                            } else if (tag === 'instance-id') {
                                let t = tag.replace('-', '_');
                                let field = data.split("-");
                                let proper = field[0]+"_"+field[1];
                                it[t] = proper;
                                process.env[t] = proper;
                            } else {
                                let t = tag.replace('-', '_');
                                it.params.push(t);
                                it[t] = data;
                                process.env[tag.toUpperCase()] = data;
                            }
                        } else return result(Promise.reject('Error no data in response'));
                        if (i === it.metas.length-1) return result(Promise.resolve())
                    })
                    .catch(error => {
                        return result(Promise.reject(error))
                    });
            }
        })
    };
    this.extractEnv = function () {
        let it = this;
        return new Promise(function (result) {
            let meta = {};
            for (let i = 0; i < it.metas.length; i++) {
                let tag = it.metas[i];
                meta[tag] = process.env[tag.toUpperCase()];
            }
            return result(meta);
        })
    }
}

module.exports = InstanceManager;